]> git.notmuchmail.org Git - notmuch/blobdiff - test/test-lib.sh
test: Add a test script for "notmuch tag"
[notmuch] / test / test-lib.sh
index 22e387e49d0a8067351de747f8ce2ea90d6f8ceb..1ea7fa976b8acd01f212c30f9627ceedcde7a9b4 100755 (executable)
@@ -39,7 +39,7 @@ done,*)
        ;;
 esac
 
-# Keep the original TERM for say_color
+# Keep the original TERM for say_color and test_emacs
 ORIGINAL_TERM=$TERM
 
 # For repeatability, reset the environment to known value.
@@ -394,7 +394,7 @@ emacs_deliver_message ()
           (message-goto-body)
           (insert \"${body}\")
           $@
-          (message-send-and-exit))" >/dev/null 2>&1
+          (message-send-and-exit))"
     wait ${smtp_dummy_pid}
     notmuch new >/dev/null
 }
@@ -424,6 +424,7 @@ test_begin_subtest ()
        error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
     fi
     test_subtest_name="$1"
+    test_subtest_known_broken_=
     # Remember stdout and stderr file descriptors and redirect test
     # output to the previously prepared file descriptors 3 and 4 (see
     # below)
@@ -448,7 +449,7 @@ test_expect_equal ()
 
        output="$1"
        expected="$2"
-       if ! test_skip "$@"
+       if ! test_skip "$test_subtest_name"
        then
                if [ "$output" = "$expected" ]; then
                        test_ok_ "$test_subtest_name"
@@ -461,6 +462,7 @@ test_expect_equal ()
     fi
 }
 
+# Like test_expect_equal, but takes two filenames.
 test_expect_equal_file ()
 {
        exec 1>&6 2>&7          # Restore stdout and stderr
@@ -471,7 +473,7 @@ test_expect_equal_file ()
 
        output="$1"
        expected="$2"
-       if ! test_skip "$@"
+       if ! test_skip "$test_subtest_name"
        then
                if diff -q "$expected" "$output" >/dev/null ; then
                        test_ok_ "$test_subtest_name"
@@ -484,29 +486,6 @@ test_expect_equal_file ()
     fi
 }
 
-test_expect_equal_failure ()
-{
-       exec 1>&6 2>&7          # Restore stdout and stderr
-       inside_subtest=
-       test "$#" = 3 && { prereq=$1; shift; } || prereq=
-       test "$#" = 2 ||
-       error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
-
-       output="$1"
-       expected="$2"
-       if ! test_skip "$@"
-       then
-               if [ "$output" = "$expected" ]; then
-                       test_known_broken_ok_ "$test_subtest_name"
-               else
-                       test_known_broken_failure_ "$test_subtest_name"
-                       testname=$this_test.$test_count
-                       echo "$expected" > $testname.expected
-                       echo "$output" > $testname.output
-               fi
-    fi
-}
-
 NOTMUCH_NEW ()
 {
     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
@@ -568,31 +547,46 @@ test_have_prereq () {
 # the text_expect_* functions instead.
 
 test_ok_ () {
+       if test "$test_subtest_known_broken_" = "t"; then
+               test_known_broken_ok_ "$@"
+               return
+       fi
        test_success=$(($test_success + 1))
        say_color pass "%-6s" "PASS"
        echo " $@"
 }
 
 test_failure_ () {
+       if test "$test_subtest_known_broken_" = "t"; then
+               test_known_broken_failure_ "$@"
+               return
+       fi
        test_failure=$(($test_failure + 1))
-       say_color error "%-6s" "FAIL"
-       echo " $1"
-       shift
+       test_failure_message_ "FAIL" "$@"
+       test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
+       return 1
+}
+
+test_failure_message_ () {
+       say_color error "%-6s" "$1"
+       echo " $2"
+       shift 2
        echo "$@" | sed -e 's/^/        /'
        if test "$verbose" != "t"; then cat test.output; fi
-       test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 }
 
 test_known_broken_ok_ () {
+       test_subtest_known_broken_=
        test_fixed=$(($test_fixed+1))
        say_color pass "%-6s" "FIXED"
        echo " $@"
 }
 
 test_known_broken_failure_ () {
+       test_subtest_known_broken_=
        test_broken=$(($test_broken+1))
-       say_color pass "%-6s" "BROKEN"
-       echo " $@"
+       test_failure_message_ "BROKEN" "$@"
+       return 1
 }
 
 test_debug () {
@@ -625,6 +619,7 @@ test_skip () {
        fi
        case "$to_skip" in
        t)
+               test_subtest_known_broken_=
                say_color skip >&3 "skipping test: $@"
                say_color skip "%-6s" "SKIP"
                echo " $1"
@@ -636,20 +631,8 @@ test_skip () {
        esac
 }
 
-test_expect_failure () {
-       test "$#" = 3 && { prereq=$1; shift; } || prereq=
-       test "$#" = 2 ||
-       error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
-       if ! test_skip "$@"
-       then
-               test_run_ "$2"
-               if [ "$?" = 0 -a "$eval_ret" = 0 ]
-               then
-                       test_known_broken_ok_ "$1"
-               else
-                       test_known_broken_failure_ "$1"
-               fi
-       fi
+test_subtest_known_broken () {
+       test_subtest_known_broken_=t
 }
 
 test_expect_success () {
@@ -742,7 +725,7 @@ test_external_without_stderr () {
        fi
 }
 
-# This is not among top-level (test_expect_success | test_expect_failure)
+# This is not among top-level (test_expect_success)
 # but is a prefix that can be used in the test script, like:
 #
 #      test_expect_success 'complain and die' '
@@ -847,7 +830,7 @@ export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
 #
 # --load               Force loading of notmuch.el and test-lib.el
 
-emacs --no-init-file --no-site-file \
+exec emacs --no-init-file --no-site-file \
        --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
        --directory "$TEST_DIRECTORY" --load test-lib.el \
        "\$@"
@@ -858,10 +841,19 @@ EOF
 test_emacs () {
        if [ -z "$EMACS_SERVER" ]; then
                EMACS_SERVER="notmuch-test-suite-$$"
-               "$TMP_DIRECTORY/run_emacs" \
-                       --daemon \
-                       --eval "(setq server-name \"$EMACS_SERVER\")" \
-                       --eval "(orphan-watchdog $$)" || return
+               # start a detached session with an emacs server
+               # user's TERM is given to dtach which assumes a minimally
+               # VT100-compatible terminal -- and emacs inherits that
+               TERM=$ORIGINAL_TERM dtach -n "$TMP_DIRECTORY/emacs-dtach-socket.$$" \
+                       sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
+                               --no-window-system \
+                               --eval '(setq server-name \"$EMACS_SERVER\")' \
+                               --eval '(server-start)' \
+                               --eval '(orphan-watchdog $$)'" || return
+               # wait until the emacs server is up
+               until test_emacs '()' 2>/dev/null; do
+                       sleep 1
+               done
        fi
 
        emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"